#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

//-------------------------------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/socket.h>
//-------------------------------------------------------------------------------------------------
#define BUFSIZE 1024
//-------------------------------------------------------------------------------------------------
int sock;
char message[BUFSIZE] = "Server <--- Client \n";
int str_len;
struct sockaddr_in serv_addr;
int flag_master = 0;
//-------------------------------------------------------------------------------------------------


void
on_button1_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button1_released                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


// SIGNAL_LEFT
//
void
on_button4_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{
	char signal[BUFSIZE] = "SIGNAL_LEFT";
	g_printf("%s\n", signal);
	write(sock, signal, strlen(signal));
}


void
on_button4_released                    (GtkButton       *button,
                                        gpointer         user_data)
{
	char signal[BUFSIZE] = "SIGNAL_STOP";
	g_printf("%s\n", signal);
	write(sock, signal, strlen(signal));
}


void
on_button7_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button7_released                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


// SIGNAL_ADVANCE
// 
void
on_button2_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{
	char signal[BUFSIZE] = "SIGNAL_ADVANCE";
	g_printf("%s\n", signal);
	write(sock, signal, strlen(signal));
}


void
on_button2_released                    (GtkButton       *button,
                                        gpointer         user_data)
{
	char signal[BUFSIZE] = "SIGNAL_STOP";
	g_printf("%s\n", signal);
	write(sock, signal, strlen(signal));
}


void
on_button5_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button5_released                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


// SIGNAL_DOWN
//
void
on_button8_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{
	char signal[BUFSIZE] = "SIGNAL_DOWN";
	g_printf("%s\n", signal);
	write(sock, signal, strlen(signal));
}


void
on_button8_released                    (GtkButton       *button,
                                        gpointer         user_data)
{
	char signal[BUFSIZE] = "SIGNAL_STOP";
	g_printf("%s\n", signal);
	write(sock, signal, strlen(signal));
}


void
on_button3_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button3_released                    (GtkButton       *button,
                                        gpointer         user_data)
{

}


// SIGNAL_RIGHT
//
void
on_button6_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{
	char signal[BUFSIZE] = "SIGNAL_RIGHT";
	g_printf("%s\n", signal);
	write(sock, signal, strlen(signal));
}


void
on_button6_released                    (GtkButton       *button,
                                        gpointer         user_data)
{
	char signal[BUFSIZE] = "SIGNAL_STOP";
	g_printf("%s\n", signal);
	write(sock, signal, strlen(signal));
}


void
on_button9_pressed                     (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_button9_released                    (GtkButton       *button,
                                        gpointer         user_data)
{

}

//-------------------------------------------------------------------------------------------------

// SERVER & CLIENT - JOIN
void
on_button_join_pressed                 (GtkButton       *button,
                                        gpointer         user_data)
{
	if(flag_master == 1){
		return;
	}
	flag_master = 1;
	
	// ===>	

	GtkWidget *entry = get_edit();
	const gchar *entry_text = "";
	entry_text = gtk_entry_get_text(GTK_ENTRY(entry));
	g_printf("Entry contents (IP) : %s \n", entry_text);

	// ===>
	
	g_printf("connect ! \n");
	
	sock = socket(PF_INET, SOCK_STREAM, 0);
	
	if(sock == -1){
		g_printf("error. 1\n");
	}
	
	memset(&serv_addr, 0, sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = inet_addr(entry_text);
	serv_addr.sin_port = htons(atoi("9000"));
	
	if(connect(sock, (struct sockaddr *)&serv_addr, sizeof(serv_addr)) == -1){
		g_printf("error. 2\n");
	}
	
	write(sock, message, strlen(message)); 
	
	// message receive & send
	str_len = read(sock, message, BUFSIZE-1);
	message[str_len] = 0;
	
	printf("Receive Message : %s \n", message);
}

void
on_button_join_released                (GtkButton       *button,
                                        gpointer         user_data)
{

}

//-------------------------------------------------------------------------------------------------
